Index: NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/closea.F90
===================================================================
--- NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/closea.F90	(revision 14651)
+++ NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/closea.F90	(revision 14652)
@@ -259,5 +259,5 @@
       IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'alloc_csmask: failed to allocate surf array')
       !
-   END SUBROUTINE
+   END SUBROUTINE alloc_csmask
 
 END MODULE closea
Index: NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/daymod.F90
===================================================================
--- NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/daymod.F90	(revision 14651)
+++ NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/daymod.F90	(revision 14652)
@@ -199,5 +199,5 @@
       END DO
       !
-   END SUBROUTINE
+   END SUBROUTINE day_mth
 
 
Index: NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ICB/icbutl.F90
===================================================================
--- NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ICB/icbutl.F90	(revision 14651)
+++ NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ICB/icbutl.F90	(revision 14652)
@@ -521,5 +521,5 @@
       END DO
       kb = MIN(kb - 1,jpk)
-   END SUBROUTINE
+   END SUBROUTINE icb_utl_getkb
 
    SUBROUTINE icb_utl_zavg(pzavg, pdat, pe3, pD, kb )
@@ -546,5 +546,5 @@
       ! if kb not limited by mbkt => ocean value over mask is used (ie 0.0 for u, v)
       pzavg = ( pzavg + (pD - zdep)*pdat(kb)) / pD
-   END SUBROUTINE
+   END SUBROUTINE icb_utl_zavg
 
    SUBROUTINE icb_utl_add( bergvals, ptvals )
Index: NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfdiags.F90
===================================================================
--- NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfdiags.F90	(revision 14651)
+++ NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfdiags.F90	(revision 14652)
@@ -73,5 +73,5 @@
       IF ( iom_use( TRIM(cvarqhc3d)  ) ) CALL isf_diags_2dto3d( Kmm, ktop, kbot, phtbl, pfrac, TRIM(cvarqhc3d)  , pqhc (:,:))
       !
-   END SUBROUTINE
+   END SUBROUTINE isf_diags_flx
 
    SUBROUTINE isf_diags_2dto3d(Kmm, ktop, kbot, phtbl, pfrac, cdvar, pvar2d)
Index: NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_prep.F90
===================================================================
--- NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_prep.F90	(revision 14651)
+++ NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_prep.F90	(revision 14652)
@@ -738,5 +738,5 @@
       ENDIF
 
-   END SUBROUTINE
+   END SUBROUTINE calc_month_len
 
    SUBROUTINE obs_coo_tim_prof( kcycle,                                   &
Index: NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/sbcclo.F90
===================================================================
--- NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/sbcclo.F90	(revision 14651)
+++ NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/sbcclo.F90	(revision 14652)
@@ -160,5 +160,5 @@
       END DO  ! jcs
 
-   END SUBROUTINE
+   END SUBROUTINE get_cssrcsurf
 
    SUBROUTINE get_cstrgsurf(kncs, kmaskcs, kmaskcsgrp, psurftrg, kcsgrp )
@@ -212,5 +212,5 @@
       END DO ! jcs
 
-   END SUBROUTINE
+   END SUBROUTINE get_cstrgsurf
 
    SUBROUTINE prt_csctl(kncs, psurfsrc, psurftrg, kcsgrp, cdcstype)
@@ -246,5 +246,5 @@
       END IF
 
-   END SUBROUTINE
+   END SUBROUTINE prt_csctl
 
    SUBROUTINE sbc_csupdate(kncs, kcsgrp, kmsk_src, kmsk_grp, psurfsrc, psurftrg, cdcstype, kmsk_opnsea, psurf_opnsea, pwcs, pqcs)
@@ -318,5 +318,5 @@
       END DO ! jcs
 
-   END SUBROUTINE
+   END SUBROUTINE sbc_csupdate
 
    SUBROUTINE alloc_csarr( klen, pvarsrc, pvartrg, kvargrp )
@@ -346,5 +346,5 @@
       pvartrg(:) = 0.e0_wp
       kvargrp(:) = 0
-   END SUBROUTINE
+   END SUBROUTINE alloc_csarr
 
 END MODULE