Index: utils/CI/sette_r14244_crayftn_877/BATCH_TEMPLATE/batch-XC40_METO
===================================================================
--- utils/CI/sette_r14244_crayftn_877/BATCH_TEMPLATE/batch-XC40_METO	(revision 14691)
+++ utils/CI/sette_r14244_crayftn_877/BATCH_TEMPLATE/batch-XC40_METO	(revision 14694)
@@ -57,4 +57,36 @@
 #
   cd $EXE_DIR
+
+#add comma after logical
+for nml in `find ./ -name '*namelist_*'`
+do
+chk=$(grep -c -i -e"= *.false.," -e"= *.true.," $nml)
+if test $chk -eq 0 ; then
+echo "Changing : "$nml
+ed - $nml << EOF
+%s/=\( *\).false./=\1.false.,/
+w
+q
+EOF
+ed - $nml << EOF
+%s/=\( *\).FALSE./=\1.FALSE.,/
+w
+q
+EOF
+ed - $nml << EOF
+%s/=\( *\).true./=\1.true.,/
+w
+q
+EOF
+ed - $nml << EOF
+%s/=\( *\).TRUE./=\1.TRUE.,/
+w
+q
+EOF
+else
+echo $nml " may have already been processed: "$chk" lines already correct"
+fi
+done
+#end add comma after logical
   echo Directory is `pwd`
   
Index: utils/CI/sette_r14244_crayftn_877/sette_reference-configurations.sh
===================================================================
--- utils/CI/sette_r14244_crayftn_877/sette_reference-configurations.sh	(revision 14691)
+++ utils/CI/sette_r14244_crayftn_877/sette_reference-configurations.sh	(revision 14694)
@@ -204,5 +204,5 @@
     clean_config GYRE_PISCES GYRE_PISCES_ST 'cfgs'
     #
-    . ./makenemo -m ${CMP_NAM} -n GYRE_PISCES_ST -r GYRE_PISCES -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n GYRE_PISCES_ST -r GYRE_PISCES -j 1 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -356,5 +356,5 @@
     clean_config ORCA2_ICE_PISCES ORCA2_ICE_PISCES_ST 'cfgs'
     #
-    . ./makenemo -m ${CMP_NAM} -n ORCA2_ICE_PISCES_ST -r ORCA2_ICE_PISCES -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n ORCA2_ICE_PISCES_ST -r ORCA2_ICE_PISCES -j 1 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -597,5 +597,5 @@
     clean_config ORCA2_OFF_PISCES ORCA2_OFF_PISCES_ST 'cfgs'
     #
-    . ./makenemo -m ${CMP_NAM} -n ORCA2_OFF_PISCES_ST -r ORCA2_OFF_PISCES -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n ORCA2_OFF_PISCES_ST -r ORCA2_OFF_PISCES -j 1 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -783,5 +783,5 @@
     clean_config AMM12 AMM12_ST 'cfgs'
     #
-    . ./makenemo -m ${CMP_NAM} -n AMM12_ST -r AMM12 -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n AMM12_ST -r AMM12 -j 1 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -923,5 +923,5 @@
     clean_config ORCA2_SAS_ICE ORCA2_SAS_ICE_ST 'cfgs'
     #
-    . ./makenemo -m ${CMP_NAM} -n ORCA2_SAS_ICE_ST -r ORCA2_SAS_ICE -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n ORCA2_SAS_ICE_ST -r ORCA2_SAS_ICE -j 1 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1075,5 +1075,5 @@
     clean_config ORCA2_ICE_PISCES ORCA2_ICE_OBS_ST 'cfgs'
     #
-    . ./makenemo -m ${CMP_NAM} -n ORCA2_ICE_OBS_ST -r ORCA2_ICE_PISCES -d "OCE ICE"  -j 8 add_key "key_asminc ${ADD_KEYS}" del_key "key_top ${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n ORCA2_ICE_OBS_ST -r ORCA2_ICE_PISCES -d "OCE ICE"  -j 1 add_key "key_asminc ${ADD_KEYS}" del_key "key_top ${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1199,5 +1199,5 @@
     clean_config AGRIF_DEMO AGRIF_DEMO_ST 'cfgs'
     #
-    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_ST -r AGRIF_DEMO -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_ST -r AGRIF_DEMO -j 1 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1457,5 +1457,5 @@
     clean_config AGRIF_DEMO AGRIF_DEMO_NOAGRIF_ST 'cfgs'
     #
-    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_NOAGRIF_ST -r AGRIF_DEMO -j 8 add_key "${ADD_KEYS}" del_key "key_agrif ${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_NOAGRIF_ST -r AGRIF_DEMO -j 1 add_key "${ADD_KEYS}" del_key "key_agrif ${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1506,5 +1506,5 @@
     clean_config WED025 WED025_ST 'cfgs'
     #
-    . ./makenemo -m ${CMP_NAM} -n WED025_ST -r WED025 -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n WED025_ST -r WED025 -j 1 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
Index: utils/CI/sette_r14244_crayftn_877/sette_test-cases.sh
===================================================================
--- utils/CI/sette_r14244_crayftn_877/sette_test-cases.sh	(revision 14691)
+++ utils/CI/sette_r14244_crayftn_877/sette_test-cases.sh	(revision 14694)
@@ -202,5 +202,5 @@
     sync_config  OVERFLOW OVERFLOW_ST 'tests'
     #
-    . ./makenemo -m ${CMP_NAM} -n OVERFLOW_ST -a OVERFLOW -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n OVERFLOW_ST -a OVERFLOW -j 1 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -324,5 +324,5 @@
     sync_config  LOCK_EXCHANGE LOCK_EXCHANGE_ST 'tests'
     #
-    . ./makenemo -m ${CMP_NAM} -n LOCK_EXCHANGE_ST -a LOCK_EXCHANGE -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n LOCK_EXCHANGE_ST -a LOCK_EXCHANGE -j 1 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -448,5 +448,5 @@
     sync_config  VORTEX VORTEX_ST 'tests'
     #
-    . ./makenemo -m ${CMP_NAM} -n VORTEX_ST -a VORTEX -j 8  add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n VORTEX_ST -a VORTEX -j 1  add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -632,5 +632,5 @@
     sync_config  ICE_AGRIF ICE_AGRIF_ST 'tests'
     #
-    . ./makenemo -m ${CMP_NAM} -n ICE_AGRIF_ST -a ICE_AGRIF -j 8  add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n ICE_AGRIF_ST -a ICE_AGRIF -j 1  add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -823,5 +823,5 @@
     sync_config  ISOMIP+ ISOMIP+_ST 'tests'
     #
-    . ./makenemo -m ${CMP_NAM} -n ISOMIP+_ST -a ISOMIP+ -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n ISOMIP+_ST -a ISOMIP+ -j 1 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -973,5 +973,5 @@
     sync_config  SWG SWG_ST 'tests'
     #
-    . ./makenemo -m ${CMP_NAM} -n SWG_ST -a SWG -j 8  add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    . ./makenemo -m ${CMP_NAM} -n SWG_ST -a SWG -j 1  add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg