Index: NEMO/releases/r4.0/r4.0.6/CHANGES
===================================================================
--- NEMO/releases/r4.0/r4.0.6/CHANGES	(revision 14696)
+++ NEMO/releases/r4.0/r4.0.6/CHANGES	(revision 14696)
@@ -0,0 +1,92 @@
+#######
+Commits
+#######
+
+------------------------------------------------------------------------
+r14596 | clem | 2021-03-08 09:17:56 +0100 (Mon, 08 Mar 2021) | 1 line
+
+just cosmetics
+------------------------------------------------------------------------
+r14590 | clem | 2021-03-05 14:21:05 +0100 (Fri, 05 Mar 2021) | 1 line
+
+4.0-HEAD: solve ticket #2627 to allow simulations with conductive fluxes instead of normal fluxes on top of sea ice (MetO requirement). I do not think I tackled all the issues but this is the best I can do without having a proper configuration to test it.
+------------------------------------------------------------------------
+r14588 | clem | 2021-03-05 08:42:07 +0100 (Fri, 05 Mar 2021) | 1 line
+
+solve ticket #2562
+------------------------------------------------------------------------
+r14582 | clem | 2021-03-04 10:55:13 +0100 (Thu, 04 Mar 2021) | 1 line
+
+4.0-HEAD: solve ticket #2635
+------------------------------------------------------------------------
+r14580 | clem | 2021-03-04 10:32:30 +0100 (Thu, 04 Mar 2021) | 1 line
+
+4.0-HEAD: solve ticket #2620
+------------------------------------------------------------------------
+r14523 | cetlod | 2021-02-22 12:54:54 +0100 (Mon, 22 Feb 2021) | 1 line
+
+r4.0-HEAD : minor fix for C14 output name
+------------------------------------------------------------------------
+r14508 | nicolasmartin | 2021-02-19 11:58:39 +0100 (Fri, 19 Feb 2021) | 1 line
+
+Apply remaining patches
+------------------------------------------------------------------------
+r14503 | nicolasmartin | 2021-02-18 20:59:24 +0100 (Thu, 18 Feb 2021) | 1 line
+
+Apply same patches as the related tags
+------------------------------------------------------------------------
+r14469 | clem | 2021-02-16 15:34:07 +0100 (Tue, 16 Feb 2021) | 1 line
+
+4.0-HEAD: trivial but very important bug fix in sea ice as described in ticket #2626
+------------------------------------------------------------------------
+r14467 | nicolasmartin | 2021-02-16 00:32:56 +0100 (Tue, 16 Feb 2021) | 1 line
+
+Fix documentation generation (manual and guide)
+------------------------------------------------------------------------
+r14444 | clem | 2021-02-11 19:25:42 +0100 (Thu, 11 Feb 2021) | 1 line
+
+some corrections on the html user guide
+------------------------------------------------------------------------
+r14435 | smasson | 2021-02-11 09:30:20 +0100 (Thu, 11 Feb 2021) | 1 line
+
+r4.0-HEAD: fix agrif + coupled model, #2621
+------------------------------------------------------------------------
+r14372 | mathiot | 2021-02-02 18:42:36 +0100 (Tue, 02 Feb 2021) | 1 line
+
+ticket #2581: merge ticket branch into r4.0-HEAD after Dave review
+------------------------------------------------------------------------
+r14359 | nicolasmartin | 2021-01-28 17:01:31 +0100 (Thu, 28 Jan 2021) | 1 line
+
+Fix for compiling user guide due to backward incompatibility of sphinxcontrib.bibtex
+------------------------------------------------------------------------
+
+#######
+Changes
+#######
+
+M       cfgs/SHARED/field_def_nemo-ice.xml
+M       cfgs/SHARED/field_def_nemo-innerttrc.xml
+M       cfgs/SHARED/namelist_ref
+A       CHANGES
+M       doc/latex/global/document.tex
+M       doc/latex/global/frontpage.tex
+M       doc/latex/global/new_cmds.tex
+M       doc/rst/source/conf.py
+M       doc/rst/source/guide.rst
+M       INSTALL.rst
+M       src/ICE/icectl.F90
+M       src/ICE/icesbc.F90
+M       src/ICE/iceupdate.F90
+M       src/ICE/icewri.F90
+M       src/OCE/DIA/diawri.F90
+M       src/OCE/DYN/dynvor.F90
+M       src/OCE/ICB/icbdia.F90
+M       src/OCE/ICB/icbdyn.F90
+M       src/OCE/ICB/icbutl.F90
+M       src/OCE/SBC/cpl_oasis3.F90
+M       src/OCE/SBC/sbccpl.F90
+M       src/OCE/SBC/sbcice_cice.F90
+M       src/OCE/SBC/sbcwave.F90
+M       src/TOP/PISCES/P4Z/p4zsed.F90
+M       src/TOP/trc.F90
+M       tests/README.rst